;-----------------------------------------------
; SYSMETS.INC -- System metrics display structure
;-----------------------------------------------

items	STRUCT

iIndex	sdword	?		; Index, 4 bytes	
szLabel	byte	22 DUP (?)	; Label field
	byte	NULL	
szDesc	byte	42 DUP (?)	; Descriptive field
	byte	NULL		; Total = 70 bytes
items	ENDS

;	    Index		    Label			Decription  

sysmetrics \
items   <SM_CXSCREEN, 		'SM_CXSCREEN',,		'Screen width in pixels'>
items   <SM_CYSCREEN,		'SM_CYSCREEN',,		'Screen height in pixels'>
items   <SM_CXVSCROLL,		'SM_CXVSCROLL',,	'Vertical scroll width'>
items   <SM_CYHSCROLL,		'SM_CYHSCROLL',,	'Horizontal scroll height'>
items   <SM_CYCAPTION,		'SM_CYCAPTION',,	'Caption bar height'>
items   <SM_CXBORDER,		'SM_CXBORDER',,		'Window border width'>
items   <SM_CYBORDER,		'SM_CYBORDER',,		'Window border height'>
items   <SM_CXFIXEDFRAME,	'SM_CXFIXEDFRAME',,	'Dialog window frame width'>
items   <SM_CYFIXEDFRAME,	'SM_CYFIXEDFRAME',,	'Dialog window frame height'>
items   <SM_CYVTHUMB,		'SM_CYVTHUMB',,		'Vertical scroll thumb height'>
items   <SM_CXHTHUMB,		'SM_CXHTHUMB',,		'Horizontal scroll thumb width'>
items   <SM_CXICON,		'SM_CXICON',,		'Icon width'>
items   <SM_CYICON,		'SM_CYICON',,		'Icon height'>
items   <SM_CXCURSOR,		'SM_CXCURSOR',,		'Cursor width'>
items   <SM_CYCURSOR,		'SM_CYCURSOR',,		'Cursor height'>
items   <SM_CYMENU,		'SM_CYMENU',,		'Menu bar height'>
items   <SM_CXFULLSCREEN,	'SM_CXFULLSCREEN',,	'Full screen client area width'>
items   <SM_CYFULLSCREEN,	'SM_CYFULLSCREEN',,	'Full screen client area height'>
items   <SM_CYKANJIWINDOW,	'SM_CYKANJIWINDOW',,	'Kanji window height'>
items   <SM_MOUSEPRESENT,	'SM_MOUSEPRESENT',,	'Mouse present flag'>
items   <SM_CYVSCROLL,		'SM_CYVSCROLL',,	'Vertical scroll arrow height'>
items   <SM_CXHSCROLL,		'SM_CXHSCROLL',,	'Horizontal scroll arrow width'>
items   <SM_DEBUG,		'SM_DEBUG',,		'Debug version flag'>
items   <SM_SWAPBUTTON,		'SM_SWAPBUTTON',,	'Mouse buttons swapped flag'>
items   <SM_CXMIN,		'SM_CXMIN',,		'Minimum window width'>
items   <SM_CYMIN,		'SM_CYMIN',,		'Minimum window height'>
items   <SM_CXSIZE,		'SM_CXSIZE',,		'Min/Max/Close button width'>
items   <SM_CYSIZE,		'SM_CYSIZE',,		'Min/Max/Close button height'>
items   <SM_CXSIZEFRAME,	'SM_CXSIZEFRAME',,	'Window sizing frame width'>
items   <SM_CYSIZEFRAME,	'SM_CYSIZEFRAME',,	'Window sizing frame height'>
items   <SM_CXMINTRACK,		'SM_CXMINTRACK',,	'Minimum window tracking width'>
items   <SM_CYMINTRACK,		'SM_CYMINTRACK',,	'Minimum window tracking height'>
items   <SM_CXDOUBLECLK,	'SM_CXDOUBLECLK',,	'Double click x tolerance'>
items   <SM_CYDOUBLECLK,	'SM_CYDOUBLECLK',,	'Double click y tolerance'>
items   <SM_CXICONSPACING,	'SM_CXICONSPACING',,	'Horizontal icon spacing'>
items   <SM_CYICONSPACING,	'SM_CYICONSPACING',,	'Vertical icon spacing'>
items   <SM_MENUDROPALIGNMENT,	'SM_MENUDROPALIGNMENT',,'Left or right menu drop'>
items   <SM_PENWINDOWS,		'SM_PENWINDOWS',,	'Pen extensions installed'>
items   <SM_DBCSENABLED,	'SM_DBCSENABLED',,	'Double- Char Set enabled'>
items   <SM_CMOUSEBUTTONS,	'SM_CMOUSEBUTTONS',,	'Number of mouse buttons'>
items   <SM_SECURE,		'SM_SECURE',,		'Security present flag'>
items   <SM_CXEDGE,		'SM_CXEDGE',,		'3-D border width'>
items   <SM_CYEDGE,		'SM_CYEDGE',,		'3-D border height'>
items   <SM_CXMINSPACING,	'SM_CXMINSPACING',,	'Minimized window spacing width'>
items   <SM_CYMINSPACING,	'SM_CYMINSPACING',,	'Minimized window spacing height'>
items   <SM_CXSMICON,		'SM_CXSMICON',,		'Small icon width'>
items   <SM_CYSMICON,		'SM_CYSMICON',,		'Small icon height'>
items   <SM_CYSMCAPTION,	'SM_CYSMCAPTION',,	'Small caption height'>
items   <SM_CXSMSIZE,		'SM_CXSMSIZE',,		'Small caption button width'>
items   <SM_CYSMSIZE,		'SM_CYSMSIZE',,		'Small caption button height'>
items   <SM_CXMENUSIZE,		'SM_CXMENUSIZE',,	'Menu bar button width'>
items   <SM_CYMENUSIZE,		'SM_CYMENUSIZE',,	'Menu bar button height'>
items   <SM_ARRANGE,		'SM_ARRANGE',,		'How minimized windows arranged'>
items   <SM_CXMINIMIZED,	'SM_CXMINIMIZED',,	'Minimized window width'>
items   <SM_CYMINIMIZED,	'SM_CYMINIMIZED',,	'Minimized window height'>
items   <SM_CXMAXTRACK,		'SM_CXMAXTRACK',,	'Maximum draggable width'>
items   <SM_CYMAXTRACK,		'SM_CYMAXTRACK',,	'Maximum draggable height'>
items   <SM_CXMAXIMIZED,	'SM_CXMAXIMIZED',,	'Width of maximized window'>
items   <SM_CYMAXIMIZED,	'SM_CYMAXIMIZED',,	'Height of maximized window'>
items   <SM_NETWORK,		'SM_NETWORK',,		'Network present flag'>
items   <SM_CLEANBOOT,		'SM_CLEANBOOT',,		'How system was booted'>
items   <SM_CXDRAG,		'SM_CXDRAG',,		'Avoid drag x tolerance'>
items   <SM_CYDRAG,		'SM_CYDRAG',,		'Avoid drag y tolerance'>
items   <SM_SHOWSOUNDS,		'SM_SHOWSOUNDS',,	'Present sounds visually'>
items   <SM_CXMENUCHECK,	'SM_CXMENUCHECK',,	'Menu check-mark width'>
items   <SM_CYMENUCHECK,	'SM_CYMENUCHECK',,	'Menu check-mark height'>
items   <SM_SLOWMACHINE,	'SM_SLOWMACHINE',,	'Slow processor flag'>
items   <SM_MIDEASTENABLED,	'SM_MIDEASTENABLED',,	'Hebrew and Arabic enabled flag'>
items   <SM_MOUSEWHEELPRESENT,	'SM_MOUSEWHEELPRESENT',,'Mouse wheel present flag'>
items   <SM_XVIRTUALSCREEN,	'SM_XVIRTUALSCREEN',,	'Virtual screen x origin'>
items   <SM_YVIRTUALSCREEN,	'SM_YVIRTUALSCREEN',,	'Virtual screen y origin'>
items   <SM_CXVIRTUALSCREEN,	'SM_CXVIRTUALSCREEN',,	'Virtual screen width'>
items   <SM_CYVIRTUALSCREEN,	'SM_CYVIRTUALSCREEN',,	'Virtual screen height'>
items   <SM_CMONITORS,		'SM_CMONITORS',,	'Number of monitors'>
items   <SM_SAMEDISPLAYFORMAT,	'SM_SAMEDISPLAYFORMAT',,'Same color format flag'>

NUMLINES EQU	75 

